	
	/*************** DATA TABLES *****************/
	// jquery function for sorting, paging and filtering all table
	// 	
	// OPTIONS: 
	// 	- table must have class if you want to initialize data tables		(sortable_table) !!!!
	// 	- if you want to make column not sortable just add class to TH 		(no_sort)
	// 	- if you want to make table exportable just add class 				(exportable_table)
	// 	- if you want to make column not sortable just add class to TH 		(no_export)
	//	- if you want to make column aligned center just add class to TH 	(align_center)
	
	// var target		= target element to find datatables in (Example: body, .some_class, #some_id, etc.) DEFAULT: body
	function data_table_init(target)
	{
		if(!target) target = 'body';
		
		if($(".sortable_table", target).length > 0)
		{
			var counter = 0;
			
			var bProcessing;
			var bServerSide;
			var ajaxSource;
			
			$(".sortable_table", target).each(function(){
				var aoColumns = [];
				var exportColumns = [];
				var centerColumns = [];

				$('thead th', this).each(function(){

					// Customize sorting
				    if($(this).hasClass('no_sort'))
				        aoColumns.push( { "bSortable": false } );
				    else
				    {
				    	if($(this).hasClass('number_sort'))
				    	{
//				    		aoColumns.push( { "sSortDataType": "dom-text", "sType": "numeric" } );
				    		aoColumns.push( { "sSortDataType": "dom-text", "sType": "numeric" } );
				    	}
				    	else
				    	{
				    		aoColumns.push( null );
				    	}
				    }
				    
					// Customzie exporting
				    if($(this).hasClass('no_export'))
				        exportColumns.push(counter);

					// Customize align columns
				    if($(this).hasClass('align_center'))
				        centerColumns.push(counter);
				    
				    counter++;
				});

				if($(this).hasClass('exportable_table'))
				{
					oTable = $(this).dataTable({
						//"bDestroy" : true,
						/*"bServerSide": bServerSide,
						"bProcessing": bProcessing,
						"sAjaxSource": ajaxSource,*/
						"sDom": 'Tlfrt<"F"ip>',
						"oTableTools": {
							"sSwfPath": base_url + "assets/data_tables/swf/copy_cvs_xls_pdf.swf",
							"aButtons": [
//					                { 
//					                	// Drop down menu with this three optiones
//					                    "sExtends":    "collection",
//					                    "sButtonText": "Export table",
//					                    "aButtons":    [ "csv", "xls", "pdf" ]
//					                }
				                {
				                    "sExtends": "csv",
				                    "mColumns": exportColumns
				                },
				                {
				                    "sExtends": "xls",
				                    "mColumns": exportColumns
				                }
				            ]
						},
						"sPaginationType": "input",	// Set pagination style
				        "bScrollCollapse": true,
				        "bFilter": false,			// Hide search field from top
				        "bJQueryUI": true,			// Use jQuery UI css style
				        "bStateSave": true,			// Save state of table
				        "aoColumnDefs": [{ 
				        	"aTargets": [-1]
				        }],
				        "aoColumns": aoColumns
				    });
				}
				else
				{
					oTable = $(this).dataTable({
						//"bDestroy" : true,
						/*"bServerSide": bServerSide,
						"bProcessing": bProcessing,
						"sAjaxSource": ajaxSource,*/
						"sPaginationType": "input",	// Set pagination style
				        "bScrollCollapse": true,
				        "bFilter": false,			// Hide search field from top
				        "bJQueryUI": true,			// Use jQuery UI css style
				        "bStateSave": true,			// Save state of table
				        "aoColumnDefs": [{ 
				        	"aTargets": [-1]
				        }],
				        "aoColumns": aoColumns,
				        "fnRowCallback": function(nRow, aData, iDisplayIndex, iDisplayIndexFull){

							if(centerColumns.length > 0)
							{
								// If corresponding TH element has class "align_center"
								// content in TD element will be aligned
								var $elements = $(nRow).children();

								for(var c = 0; c < centerColumns.length; c++)
									$elements.eq(centerColumns[c]).css('text-align', 'center');
							}
							
				            return nRow;
						}
				    });
				}
			});
			return oTable;
		}
	}
	
	$(document).ready(function() {

		// Initiate datatables
		oTable = data_table_init();
		
		
	}); 
