/*
# CKEDITOR Edit-In Place jQuery Plugin.
# Created By Dave Earley.
# www.Dave-Earley.com
*/

$.fn.ckeip = function (options, callback) {

    var original_html = $(this);
    var defaults = {
        e_height		: '10',
        data			: {}, 
        e_url			: '',
        e_hover_color	: '#eeeeee',
        ckeditor_config	: '',
        e_width			: '50',
        database_content: false // If not "false" it will accept URL to get content from database
    };
    var settings = $.extend({}, defaults, options);

    return this.each(function () {
        
    	if(!settings.database_content)
    	{
    		var eip_html = $(this).html();
    	}
    	else
    	{
    		var eip_html = '';
    		$.ajax({
				type: "POST",
				url: settings.database_content,
				success: function(data){
    				eip_html = data;
    			},
				async: false
			 });
    	}
    	
        var u_id = Math.floor(Math.random() * 99999999);

        // Custom VPharmacy links
        var saveLink 	= '<div class="orange_btn">' + 
							'<div class="orange_btn_left"></div>' + 
							'<div class="orange_btn_middle">' + 
								'<a href="#" id="save_ckeip_' + u_id + '">Save</a>' + 
							'</div>' + 
							'<div class="orange_btn_right"></div>' + 
						'</div>';
        var cancelLink 	= '<div class="orange_btn">' + 
							'<div class="orange_btn_left"></div>' + 
							'<div class="orange_btn_middle">' + 
								'<a href="#" id="cancel_ckeip_' + u_id + '">Cancel</a>' + 
							'</div>' + 
							'<div class="orange_btn_right"></div>' + 
						'</div>';
        // Default links
        //$(this).before("<div id='ckeip_" + u_id + "'  style='display:none;'><textarea id ='ckeip_e_" + u_id + "' cols='" + settings.e_width + "' rows='" + settings.e_height + "'  >" + eip_html + "</textarea>  <br /><a href='#' id='save_ckeip_" + u_id + "'>Save</a> <a href='#' id='cancel_ckeip_" + u_id + "'>Canel </a></div>");
        
        // Custom VPharmacy links defined above
        $(this).before("<div id='ckeip_" + u_id + "'  style='display:none;'><textarea id ='ckeip_e_" + u_id + "' cols='" + settings.e_width + "' rows='" + settings.e_height + "'  >" + eip_html + "</textarea>  <br />" + saveLink + cancelLink + "</div>");
        Cufon.replace('.orange_btn_middle a', { fontFamily: 'DINOT-Medium', hover: true });
        
        $('#ckeip_e_' + u_id + '').ckeditor(settings.ckeditor_config);

        $(this).bind("dblclick", function () {

            $(this).hide();
            $('#ckeip_' + u_id + '').show();

        });

        $(this).hover(function () {
            $(this).css({
                backgroundColor: settings.e_hover_color
            });
        }, function () {
            $(this).css({
                backgroundColor: ''
            });
        });


        $("#cancel_ckeip_" + u_id + "").click(function () {
            $('#ckeip_' + u_id + '').hide();
            $(original_html).fadeIn();
            return false;
        });

        $("#save_ckeip_" + u_id + "").click(function () {
            var ckeip_html = $('#ckeip_e_' + u_id + '').val();
            $.post(settings.e_url, {
                content: ckeip_html,
                data: settings.data
            }, function (response) {
                if (typeof callback == "function") callback(response);

                $(original_html).html(ckeip_html);
                $('#ckeip_' + u_id + '').hide();
                $(original_html).fadeIn();

            });;
            return false;

        });

    });
};