	$(document).ready(function(){
		
		/*************** DATEPICKER *****************/
		//jquery function for initializing datepicker
		$( "#fromDate" ).datepicker({dateFormat: 'yy-mm-dd'});
		$( "#toDate" ).datepicker({dateFormat: 'yy-mm-dd'});
		
		/*************** TABLESORTER *****************/
		//jquery function for sorting, paging and filtering news table
		
		if($("#sort_orders").length > 0)
		{
			$("#sort_orders").tablesorter({ widgets: ['zebra'], headers: { 0: { sorter: false }, 7: { sorter: false }} })
		    				.tablesorterPager({ container: $(".pager"), positionFixed: false, size: 10 });
		}
		
		/*************** ORDERS LISTING CHECKBOXES *****************/
		// Toggle "select all"
		$("#toggle_checked").change(function(){
			$("input[name='checked[]']").attr("checked", $(this).is(":checked"));
			
			// update number of checked
			$("#orders_count").html($("input[name='checked[]']:checked").length);
			
			// insert hidden form fields
			$("input[name='checked[]']:checked").each(function(){
				$("#orders_count").append('<input type="hidden" name="or_checked2[]" value="' + $(this).val() + '" />');
			});
		});
		
		// update number of checked on page load
		$("#orders_count").html($("input[name='checked[]']:checked").length);
		
		// Count number of checked on clicking checkboxes
		$("input[name='checked[]']").live('change', function(){
			
			// update number of checked
			$("#orders_count").html($("input[name='checked[]']:checked").length);
			
			// insert hidden form fields
			$("input[name='checked[]']:checked").each(function(){
				$("#orders_count").append('<input type="hidden" name="or_checked2[]" value="' + $(this).val() + '" />');
			});
		});
		
		// Order details - for retrieving credit card details
		
		$(".get_cc").click(function() {
			var priv_key = $("#private_key").val();
			var usr_id = $("#user_id").val();
			var gst = $("#guest").val();
			var dec_pass = $("#dec_pass").val();
			
			
			$.ajax({
				   type: "POST",
				   url: base_url+"admin/orders/get_cc/",
				   data: {
					   private_key : priv_key,
					   user_id	   : usr_id,
					   guest	   : gst,
					   dc_pass	   : dec_pass
					},
				   success: function(msg){
						if (msg)
						{
							msg = $.parseJSON(msg);
							$("#cc_ins").html(msg.number);
							$("#cc_exp_mon").html(msg.expiration_month);
							$("#cc_exp_year").html(msg.expiration_year);
							$("#cc_exp_code").html(msg.verification_code);
						}
						else
						{
							$("#cc_ins").html("Decryption failed. Please check your private key and password.");
							$("#cc_exp_mon").html("Decryption failed. Please check your private key and password.");
							$("#cc_exp_year").html("Decryption failed. Please check your private key and password.");
							$("#cc_exp_code").html("Decryption failed. Please check your private key and password.");
						}
				   },
				   //async: false
			 });
			return false;
		});
		
		$("#private_key").focus(function() {
			if($(this).val()=="Please enter your private key here.")
				$(this).val("");
		});
		
		$("#private_key").blur(function() {
			//alert($(this).html());
			if($(this).val()=="")
				$(this).val("Please enter your private key here.");
		});
		
	});