$(document).ready(function(){
		
	/*************** SLUG *****************/
	// Generate slug from title while user is typing
	$("input[name='title']").slug({ 
		// class of input / span that contains the generated slug 
		slug:'slug',
		// hide the text input, true by default 
		hide: false
	});
	
	// Bind onKeyUp event over slug field, so it generates slug in real time, while user is typing
	$("input[name='url_name']").bind('keyup', function(){
		var slugstring = $(this).val();
		var slugstring_hyphens = slugstring.replace(/\s/g,'-');
		var clearslug = slugstring_hyphens.replace(/[^a-zA-Z0-9\-]/g,'');
		$(this).val(clearslug.toLowerCase());
	});
	
	/*************** TREE VIEW *****************/
	// Open treeview node for curent page
    var current = $('ul.treeview').find("a").filter(function() {return this.href.toLowerCase() == location.href.toLowerCase(); });
    current.parent().addClass("selected").end().addClass("selected").parents("ul, li").add( current.next() ).show();

	/*************** ACTIVATE CHECKBOXES *****************/
	$("input[name='activate']").change(function(){
		$.ajax({
		  	url: base_url + "admin/page/publish/" + $(this).attr('id')
		});
	});
	
	/*************** DATEPICKER *****************/
	//jquery function for initializing datepicker
	$( "#fromDate" ).datepicker({dateFormat: 'yy-mm-dd'});
	$( "#toDate" ).datepicker({dateFormat: 'yy-mm-dd'});
	
	/*************** TABLESORTER *****************/
	//jquery function for sorting, paging and filtering news table
	$("#sort_pages").tablesorter({ widgets: ['zebra'], headers: { 3: { sorter: false }, 4: { sorter: false }, 5: { sorter: false } } })
    				.tablesorterPager({ container: $(".pager"), positionFixed: false, size: 10 });
	
	/*************** EDIT PAGE VALIDATION ***************************/	
	//jquery function for validation of required fields and charchter length		
	// validate signup form on keyup and submit
	$("#edit_page_form").validate({
		errorContainer: $('span.error_container'),
		rules: {
			title: {
				required: true,
				minlength: 3
			},
			url_name: {
				required: true,
				minlength: 3,
				remote: {
					url: base_url + "admin/page/check_slug_ajax",
			        type: "post",
			        data: {
			          	slug: function() {
			            	return $("#edit_page_form input[name='url_name']").val();
			          	},
			          	page_id: function() {
			            	return $("#edit_page_form input[name='page_id']").val();
			          	}
			        }
				}
			},
			intro_content: {
				required: false,
				minlength: 5
			},
			content: {
				required: true,
				minlength: 5
			},
			userfile: {
				accept:'jpg|jpeg|png|gif'
			}
		},
		messages: {
            url_name: {
				remote: jQuery.format("Page URL already exists")
            },
            userfile: {
				accept: jQuery.format("Please enter image (JPG, PNG, GIF)")
            }
        }		
	});
	
	/*************** ADD PAGE VALIDATION ***************************/    
  	//jquery function for validation of required fields and charchter length		
	// validate signup form on keyup and submit
    $("#add_page_form").validate({
		errorContainer: $('span.error_container'),
		rules: {
			title: {
				required: true,
				minlength: 3
			},
			url_name: {
				required: true,
				minlength: 3,
				remote: {
					url: base_url + "admin/page/check_slug_ajax",
			        type: "post",
			        data: {
			          	slug: function() {
			            	return $("#add_page_form input[name='url_name']").val();
			          	},
			          	page_id: function() {
			            	return $("#add_page_form input[name='page_id']").val();
			          	}
			        }
				}
			},
			intro_content: {
				required: true,
				minlength: 5
			},
			content: {
				required: true,
				minlength: 5
			},
			userfile: {
				required: true,
				accept:'jpg|jpeg|png|gif'
			}
		},
		messages: {
            url_name: {
                remote: jQuery.format("Page URL already exists")
            },
            userfile: {
				accept: jQuery.format("Please enter image (JPG, PNG, GIF)")
            }
        }		
	});
	
});
