/* Draws chart in reporting */

	//global chart:
	var productStatsChart; 
	
	//json returned from reports.php;
	var chart_array = chart_data; 
	
	
	$(document).ready(function() {

		var current_page = $('#page_display').val();
		
		//number of pages variables:
		var results_per_page = $("#results_per_page").val()*1;
		var number_of_products = chart_array.length;
		var number_of_pages =  Math.floor ( number_of_products / results_per_page );
		
		$('#search_submit').click(function(){
			
			results_per_page = $("#results_per_page").val()*1;
		});

		//sets from and to, and renders chart
		var from_to = setFromTo("next");
		renderChart(chart_array,from_to.from,from_to.to);
		
		
		//Paging:
		
		//displays current span of product (lower-right corner of paging)
		//and number of product
		renderProductSpanArea(from_to.from,from_to.to,number_of_products );
		
		$('#d_number_of_products').text(number_of_products);
		
		$('.next').click(function(){
			
			
			var current_page = $('#page_display').val()*1;
			if(current_page <= number_of_pages){
				$('#page_display').val(current_page+1);
			}
			
			var from_to = setFromTo("next");
			renderChart(chart_array,from_to.from,from_to.to);
			renderProductSpanArea(from_to.from,from_to.to,number_of_products );
			
			
		}); //end next.click
		
		$('.prev').click(function(){
			
			
			var current_page = $('#page_display').val()*1;
			
			if( current_page != 1){
				$('#page_display').val(current_page-1);
			}
			
			var from_to = setFromTo("previous");
			renderChart(chart_array,from_to.from,from_to.to);
			renderProductSpanArea(from_to.from,from_to.to,number_of_products );
			
		}); //end pre.clik
		
		$('.first').click(function(){
			
			
			var current_page = $('#page_display').val()*1;
			
			if( current_page != 1){
				$('#page_display').val(1);
			}
			
			var from_to = setFromTo("previous");
			renderChart(chart_array,from_to.from,from_to.to);
			renderProductSpanArea(from_to.from,from_to.to,number_of_products );
			
		}); //end first.clik	
		
		$('.last').click(function(){
			
			var current_page = $('#page_display').val()*1;
			
			var current_page = $('#page_display').val()*1;
			if(current_page <= number_of_pages){
				$('#page_display').val(number_of_pages+1);
			}
			
			var from_to = setFromTo("next");
			renderChart(chart_array,from_to.from,from_to.to);
			renderProductSpanArea(from_to.from,from_to.to,number_of_products );
			
		}); //end last.clik
		
		$('#page_display').keydown(function(event){
			
			
			var entered_page_number = parseInt($('#page_display').val());
			
			//Digits validation
			//allow or not zero, and num_pad zero digits:
			var zero;
			var num_pad_zero;
			
			if( (number_of_pages+1) > 10) {
				zero = 48; 			//key code for actual 0
				num_pad_zero = 96; 	//key code for actual num pad 0
			}
			else
			{
				zero = 49; 			//key code for actual 1
				num_pad_zero = 97; 	//key code for actual num pad 1
			}
			
			if ( event.keyCode == 46 || event.keyCode == 8 ) {
		           
		    }
		    else {
		    	
		    	// Ensure that it is a number and stop the keypress
		        if ((event.keyCode < zero || event.keyCode > 57) && (event.keyCode < num_pad_zero || event.keyCode > 105 )) {
		        	event.preventDefault(); 
		        }  
		     }
			
			//end validation
			
			if (event.keyCode == '13'){
				
				if( entered_page_number > current_page )
				{
					
					var from_to = setFromTo("next");
					renderChart(chart_array,from_to.from,from_to.to);
					renderProductSpanArea(from_to.from,from_to.to,number_of_products );
				}
				
				else
				{
					
					var from_to = setFromTo("previous");
					renderChart(chart_array,from_to.from,from_to.to);
					renderProductSpanArea(from_to.from,from_to.to,number_of_products );
				}
				
				if(entered_page_number < 1 ) { $('#page_display').val(1);}
				
				if(entered_page_number > number_of_pages ) { $('#page_display').val(number_of_pages+1);} 
				
			}//if keyCode
			
		});//end page.dispay keydown
      
});// end document ready
	
	
/**RENDERS CHART
 * 
 * @param chart_array 	= Array of chart data
 * @param from 			= From offset
 * @param to			= To ofset
 */	
	
function renderChart(chart_array,from,to){
	
	//array of data for x and y axis of chart
	var xaxis = [];
  	var yaxis = [];
  	
  	//getting data for x and y axis:
	for( var i=from,j=0; i < to; i++,j++ )
	{
		xaxis[j] = chart_array[i].xaxis;
		yaxis[j] = chart_array[i].yaxis;
	}
	
	//create product stats chart
	productStatsChart = new Highcharts.Chart({
		
		chart: {
        	renderTo: 'product_stats_graphs_container',
        	type: 'column'
		},
		title: {
			text: 'Product Statisics'
		},
	
		xAxis: {
			categories: xaxis
		},
	
		yAxis: {
			title: {
				text: 'Values'
	    	}
		},
		
		series:[{
			
			name:'Product',
			data:yaxis
			
		}]
		
	}); // end chart
	
}//end renderChart


/** SETS OFFSET ( FROM - TO )
 * Sets offset ( borders ) for array of chart data 
 * 
 * @param next_previous = In witch direction will values be generated
 * @return object 
 */
function setFromTo(next_previous){
	
	var results_per_page = $("#results_per_page").val()*1;
	var current_page = $('#page_display').val()*1;
	var number_of_products = chart_array.length;
	
	if ( number_of_products < results_per_page )
	{
		var from_to = {
			'to':number_of_products,
			'from':0
		}
		return from_to;
	}
	
	if (next_previous == "next"){
		
		var from = current_page;
		if(from == 1){
			from = 0;
		}
		else{
			from = (current_page-1) * results_per_page;
		}
		
		var to = from + results_per_page;
		if( to > chart_array.length){
			to = chart_array.length;
		}
		
		if (from > to - results_per_page ){
			from = to - results_per_page;
		}
	}//end if next
	
	if(next_previous == "previous" )
	{
		from = (current_page * results_per_page) - results_per_page;
		to = (current_page * results_per_page ) ;
		
	}//end if
	
	var from_to = {
			'to':to,
			'from':from
	};
	
	return from_to;
	
}//end setFrom to

/** SET VALUES AND RENDERS RIGHT PART OF PAGING AREA
 * 
 * @param from 					= from range
 * @param to 					= to range
 * @param number_of_procucts 	= full number of products
 * 
 */
function renderProductSpanArea(from,to,number_of_products){
	
	$('#d_display').html('Displaying ' + (from+1) + ' &ndash; ' + (to) +' of items ' + number_of_products);
	
}//end setPageDisplayArea




	