/* Draws chart in reporting */

	//global charts:
	var productStatsChart;
	var productPieChart;
	
	//json returned from reports.php;
	var chart_array = chart_data;
	
	
	
	$(document).ready(function() {

		var current_page = $('#page_display').val();
		
		//number of pages variables:
		if($("#results_per_page").length > 0)
		{
			var results_per_page = $("#results_per_page").val()*1;
		}
		else
		{
			var results_per_page = 10;
		}
		
		var number_of_products = chart_array.length;
		var number_of_pages =  Math.floor ( number_of_products / results_per_page );
		
		$('#search_submit').click(function(){
			
			results_per_page = $("#results_per_page").val()*1;
		});

		//sets from and to, and renders chart
		var from_to = setFromTo("next"); 
		renderChart(chart_array,from_to.from,from_to.to);
		
		
		
		//Paging:
		
		//displays current span of product (lower-right corner of paging)
		//and number of product
		
		renderProductSpanArea(from_to.from,from_to.to,number_of_products );
		
		$('#d_number_of_products').text(number_of_products);
		
		$('.next').click(function(){
			
			
			var current_page = $('#page_display').val()*1;
			if(current_page < number_of_pages){
				$('#page_display').val(current_page+1);
				var from_to = setFromTo("next");
				renderChart(chart_array,from_to.from,from_to.to);
				renderProductSpanArea(from_to.from,from_to.to,number_of_products );
			}
		}); //end next.click
		
		$('.prev').click(function(){
			
			
			var current_page = $('#page_display').val()*1;
			
			if( current_page != 1){
				$('#page_display').val(current_page-1);
				var from_to = setFromTo("previous");
				renderChart(chart_array,from_to.from,from_to.to);
				renderProductSpanArea(from_to.from,from_to.to,number_of_products );
			}
		}); //end pre.clik
		
		$('.first').click(function(){
			
			var current_page = $('#page_display').val()*1;
			
			if( current_page != 1){
				$('#page_display').val(1);
				var from_to = setFromTo("previous");
				renderChart(chart_array,from_to.from,from_to.to);
				renderProductSpanArea(from_to.from,from_to.to,number_of_products );
			}
		}); //end first.clik	
		
		$('.last').click(function(){
			
			var current_page = $('#page_display').val()*1;
			
			if(current_page < number_of_pages){
				$('#page_display').val(number_of_pages);
				var from_to = setFromTo("next");
				renderChart(chart_array,from_to.from,from_to.to);
				renderProductSpanArea(from_to.from,from_to.to,number_of_products );
			}
		}); //end last.clik
		
		$('#page_display').keydown(function(event){
			
			
			var entered_page_number = parseInt($('#page_display').val());
			
			//Digits validation
			//allow or not zero, and num_pad zero digits:
			var zero;
			var num_pad_zero;
			
			if( (number_of_pages+1) > 10) {
				zero = 48; 			//key code for actual 0
				num_pad_zero = 96; 	//key code for actual num pad 0
			}
			else
			{
				zero = 49; 			//key code for actual 1
				num_pad_zero = 97; 	//key code for actual num pad 1
			}
			
			if ( event.keyCode == 46 || event.keyCode == 8 ) {
		           
		    }
		    else {
		    	
		    	// Ensure that it is a number and stop the keypress
		        if ((event.keyCode < zero || event.keyCode > 57) && (event.keyCode < num_pad_zero || event.keyCode > 105 )) {
		        	event.preventDefault(); 
		        }  
		     }
			
			//end validation
			
			if (event.keyCode == '13'){
				
				if( entered_page_number > current_page )
				{
					
					var from_to = setFromTo("next");
					renderChart(chart_array,from_to.from,from_to.to);
					renderProductSpanArea(from_to.from,from_to.to,number_of_products );
				}
				
				else
				{
					
					var from_to = setFromTo("previous");
					renderChart(chart_array,from_to.from,from_to.to);
					renderProductSpanArea(from_to.from,from_to.to,number_of_products );
				}
				
				if(entered_page_number < 1 ) { $('#page_display').val(1);}
				
				if(entered_page_number > number_of_pages ) { 
					if(number_of_pages > 0)
					{
						$('#page_display').val(number_of_pages);
					}
					else
					{
						$('#page_display').val(number_of_pages+1);
					}
				}
			}//if keyCode
			
		});//end page.dispay keydown
		
      
});// end document ready
	
	
/**RENDERS CHART
 * 
 * @param chart_array 	= Array of chart data
 * @param from 			= From offset
 * @param to			= To ofset
 */	
	
function renderChart(chart_array,from,to){
	
	
	var products_name = [];
	var products_sold = [];
	//var product_in_wishlist = [];
	//var abandoned_products = [];
	var product_views = [];
	
	//data for stacked chart:
	for( var i=from,j=0; i < to; i++,j++ )
	{
		products_name[j] = chart_array[i].product_name;
		products_sold[j] = chart_array[i].product_sold;
		//product_in_wishlist[j]  = chart_array[i].wishlist_quantity;
		//abandoned_products[j] = chart_array[i].abandoned_cart_quantity;
		product_views[j] =  chart_array[i].product_views;
	}
	
	var series_data = [
				        
	   				{	
	   					id:'number_of_products_sold',
	   					name:'Product Sold',
	   					data:products_sold,
	   					color:"#73be21"
	   					
	   				},
	   				{
	   					id:'most_viewed_products',
	   					name:'Product Views',
	   					data:product_views,
	   					color:"#00a8e9"
	   				}
	   			];
	
	
	order_series_by = $('#sort_product_by').val();
	var sorted_series_data = sort_chart_series(series_data,order_series_by);
	
	productStatsChart = new Highcharts.Chart({
		
		chart: {
        	renderTo: 'product_stats_graphs_container',
        	type: 'column'
		},
		title: {
			text: 'Product Statisics'
		},
	
		xAxis: {
			categories: products_name
		},
	
		yAxis: {
			title: {
				text: 'Values'
	    	}
		},
		
		series: sorted_series_data,
		 plotOptions: {
			
		 	column: {
		 		stacking: 'normal'
		 		
		 	}
		}
		
	}); // end stacket chart
	

	//because dashboard calls this js to draw product stats chart
	// we disable drawing of pie chart on dashboard 		
	var pie_chart_div_exists = $('#product_pie_graphs_container').length > 0 ;

	if(pie_chart_div_exists) 
	{
	
		//data for pie chart
		for( var i=0; i < chart_array.length; i++,j++ )
		{
			products_name[j] = chart_array[i].product_name;
			products_sold[j] = chart_array[i].product_sold;
			//product_in_wishlist[j]  = chart_array[i].wishlist_quantity;
			//abandoned_products[j] = chart_array[i].abandoned_cart_quantity;
			product_views[j] =  chart_array[i].product_views;
		}
		
		var total_products_views = array_sum(product_views);
		var total_products_sold = array_sum(products_sold);
		//var total_in_wishlist = array_sum(product_in_wishlist);
		//var total_abandonet_cart = array_sum(abandoned_products);
		
		 
		productPieChart = new Highcharts.Chart({
			
		      chart: {
		         renderTo: 'product_pie_graphs_container',
		         plotBackgroundColor: null,
		         plotBorderWidth: null,
		         plotShadow: false
		      },
		      title: {
		         text: 'Total product overview'
		      },
		      tooltip: {
		         formatter: function() {
		            return '<b>'+ this.point.name +'</b>: '+ this.point.y + ' | ' + this.percentage.toFixed(2) +' %';
		         }
		      },
		      plotOptions: {
		         pie: {
		            allowPointSelect: true,
		            cursor: 'pointer',
		            dataLabels: {
		               enabled: false
		            },
		            showInLegend: true
		         }
		      },
		       series: [{
		         type: 'pie',
		         name: 'Procuts stats pie chart',
		         data: [
		            {
		            	name: 'Total Products Views',
		            	color:"#00a8e9",
		            	y: total_products_views
		            },
		            {
		            	name: 'Product Sold',
		            	color:"#73be21",
		            	y: total_products_sold
		            }
		            
		         ]
		      }],
		      
		      legend: {
		    	  layout: 'vertical',
		          align: 'right',
		          verticalAlign: 'middle', 
		          x: 0,
		          y: 0,
		          labelFormatter: function() {
		              //return this.name + ' (click to hide)';
		              return this.name +'</b>:' + this.y;
		          }
		      }
		   });
		
		
		//Render info on right side of pie chart:
		//$('#product_view_right_info').html(''+ chart_array.length);
		$('#total_product_view_right_info').html(''+ total_products_views);
	
	}//if pie_chart_div_exists 
	
	
	
}//end renderChart


/** SETS OFFSET ( FROM - TO )
 * Sets offset ( borders ) for array of chart data 
 * 
 * @param next_previous = In witch direction will values be generated
 * @return object 
 */
function setFromTo(next_previous){
	
	if($("#results_per_page").length > 0)
	{
		var results_per_page = $("#results_per_page").val()*1;
	}
	else
	{
		var results_per_page = 10;
	}
	
	var current_page = $('#page_display').val()*1;
	var number_of_products = chart_array.length;
	
	if ( number_of_products < results_per_page )
	{
		var from_to = {
			'to':number_of_products,
			'from':0
		};
		
		return from_to;
	}
	
	if (next_previous == "next"){
		
		var from = current_page;
		if(from == 1){
			from = 0;
		}
		else{
			from = (current_page-1) * results_per_page;
		}
		
		var to = from + results_per_page;
		if( to > chart_array.length){
			to = chart_array.length;
		}
		
		if (from > to - results_per_page ){
			from = to - results_per_page;
		}
	}//end if next
	
	if(next_previous == "previous" )
	{
		from = (current_page * results_per_page) - results_per_page;
		to = (current_page * results_per_page ) ;
		
	}//end if
	
	var from_to = {
			'to':to,
			'from':from
	};
	
	return from_to;
	
}//end setFrom to

/** SET VALUES AND RENDERS RIGHT PART OF PAGING AREA
 * 
 * @param from 					= from range
 * @param to 					= to range
 * @param number_of_procucts 	= full number of products
 * 
 */
function renderProductSpanArea(from,to,number_of_products){
	
	$('#d_display').html('Displaying ' + (from+1) + ' &ndash; ' + (to) +' of items ' + number_of_products);
	
}//end setPageDisplayArea


/** SIMPLE ARRAY SUM
 * 
 * @param array
 * @return sum of array elements
 */
function array_sum(array){
	
	var sum = 0;
	for(var i=0; i < array.length ; i++){
		sum += array[i];
	}
	return sum;
	
}

/** SORT SERIES DATA ARRAY
 *	Sorts series data array by placing the object with appropriate id to last place in array 
 *
 * @param series_data = object to be sorted
 * @order = in witch order to sort
 * 
 * @return sorted data
 */
function sort_chart_series(series_data,order)
{
	
	var sorted_data = series_data;
	var n = sorted_data.length - 1;
	var temp = sorted_data[n];
	
	for(var i=0; i< sorted_data.length;i++){
		
		if(sorted_data[i].id == order){
			var current = sorted_data[i];
			sorted_data[n] = current;
			sorted_data[i] = temp;
			break;
		}
	}
	
	return sorted_data;
	
	
}


	